Subject: Re: [PATCH net] net: try harder to not reuse ifindex when moving interfaces

From: Nicolas Dichtel <[email-masked]>
Date: Thu, 22 Oct 2015 17:23:38 +0200

Le 22/10/2015 17:00, Jiri Benc a écrit :
> On Thu, 22 Oct 2015 16:52:13 +0200, Nicolas Dichtel wrote:
>> With the proposed scenario:
>> 1. create netns 'new_netns'
>> 2. in root netns, move the interface with ifindex 2 to new_netns
>> 3. in new_netns, delete the interface with ifindex 2
>> 4. in new_netns, create an interface - it will get ifindex 2
>>
>> Operation 2 and 4 are done by dev_change_net_namespace() under rtnl_lock().
>> RTM_DELLINK(root netns) and RTM_NEWLINK(new_netns) are sent by this function.
>> It means that operation 3 has been done before and that RTM_DELLINK(new_netns)
>> has been sent before.
>
> Imagine the application trying to configure the interface with ifindex 2
> after your step 2. It constructs a netlink message and sends it to the
> kernel; but while doing so, steps 3 and 4 happen. Now the application
> ends up configuring a different interface than it intended to. After
> that, it polls the netlink socket and receives the notifications about
> interface disappearing and a new one appearing.
Understood.

>
> I don't see any way the user space application can prevent this. There
> will always be a race between receiving netlink notifications and
> sending config requests.
Yeah, I'm also starting to think that reducing this window is the way to go.

Thank you,
Nicolas